@building-option +create-set-co
@create $root_class named root waif:root waif,waif
@prop _."type" 10 r
;_.("aliases") = {"root waif", "waif"}
;_.("unique") = 0

@verb _:"new" this none this
@program _:new
"WIZARDLY";
set_task_perms(caller_perms());
w = new_waif();
w:initialize(@args);
return w;
.

@verb _:":initialize" this none this
@program _::initialize
"the perms check you want is probably:";
if ((caller == this) || (caller == this.class))
  "allows pass() and :new()";
else
  raise(E_PERM);
endif
.

@verb _:"isa" this none this
@program _:isa
{w, class} = args;
return (typeof(w) == this.type) && $object_utils:isa(w.class, class);
.

@verb _:"make_list" this none this rxd
@program _:make_list
"make_list(n, elt)";
"Return a list of OBJ.(PROP) for each OBJ in args[1].";
set_task_perms(caller_perms());
{len, @etc} = args;
if (len > 50)
  return {@this:make_list(len / 2, @etc), @this:make_list((len + 1) / 2, @etc)};
elseif (len < 0)
  return raise(E_RANGE);
endif
strs = {};
for foo in [1..len]
  x = this:new(@etc);
  strs = {@strs, x};
endfor
return strs;
"Copied from list utilities (#49):map_prop by James (#316) Fri Apr 11 16:46:24 2003 EDT";
"Copied from cell waif (#4995):make_list by Xplat (#4014) Tue Aug 30 05:35:34 2005 PDT";
.

"***finished***
